<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>LoggingConfiguration.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Test App J Hipster</a> &gt; <a href="index.source.html" class="el_package">com.theo.myjhipster.config</a> &gt; <span class="el_source">LoggingConfiguration.java</span></div><h1>LoggingConfiguration.java</h1><pre class="source lang-java linenums">package com.theo.myjhipster.config;

import java.net.InetSocketAddress;
import java.util.Iterator;

import io.github.jhipster.config.JHipsterProperties;

import ch.qos.logback.classic.AsyncAppender;
import ch.qos.logback.classic.Level;
import ch.qos.logback.classic.LoggerContext;
import ch.qos.logback.classic.boolex.OnMarkerEvaluator;
import ch.qos.logback.classic.spi.ILoggingEvent;
import ch.qos.logback.classic.spi.LoggerContextListener;
import ch.qos.logback.core.Appender;
import ch.qos.logback.core.filter.EvaluatorFilter;
import ch.qos.logback.core.spi.ContextAwareBase;
import ch.qos.logback.core.spi.FilterReply;
import net.logstash.logback.appender.LogstashTcpSocketAppender;
import net.logstash.logback.encoder.LogstashEncoder;
import net.logstash.logback.stacktrace.ShortenedThrowableConverter;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Configuration;

@Configuration
public class LoggingConfiguration {

    private static final String LOGSTASH_APPENDER_NAME = &quot;LOGSTASH&quot;;

    private static final String ASYNC_LOGSTASH_APPENDER_NAME = &quot;ASYNC_LOGSTASH&quot;;

<span class="fc" id="L33">    private final Logger log = LoggerFactory.getLogger(LoggingConfiguration.class);</span>

<span class="fc" id="L35">    private LoggerContext context = (LoggerContext) LoggerFactory.getILoggerFactory();</span>

    private final String appName;

    private final String serverPort;

    private final JHipsterProperties jHipsterProperties;

    public LoggingConfiguration(@Value(&quot;${spring.application.name}&quot;) String appName, @Value(&quot;${server.port}&quot;) String serverPort,
<span class="fc" id="L44">         JHipsterProperties jHipsterProperties) {</span>
<span class="fc" id="L45">        this.appName = appName;</span>
<span class="fc" id="L46">        this.serverPort = serverPort;</span>
<span class="fc" id="L47">        this.jHipsterProperties = jHipsterProperties;</span>
<span class="pc bpc" id="L48" title="1 of 2 branches missed.">        if (jHipsterProperties.getLogging().getLogstash().isEnabled()) {</span>
<span class="fc" id="L49">            addLogstashAppender(context);</span>
<span class="fc" id="L50">            addContextListener(context);</span>
        }
<span class="pc bpc" id="L52" title="1 of 2 branches missed.">        if (jHipsterProperties.getMetrics().getLogs().isEnabled()) {</span>
<span class="fc" id="L53">            setMetricsMarkerLogbackFilter(context);</span>
        }
<span class="fc" id="L55">    }</span>

    private void addContextListener(LoggerContext context) {
<span class="fc" id="L58">        LogbackLoggerContextListener loggerContextListener = new LogbackLoggerContextListener();</span>
<span class="fc" id="L59">        loggerContextListener.setContext(context);</span>
<span class="fc" id="L60">        context.addListener(loggerContextListener);</span>
<span class="fc" id="L61">    }</span>

    private void addLogstashAppender(LoggerContext context) {
<span class="fc" id="L64">        log.info(&quot;Initializing Logstash logging&quot;);</span>

<span class="fc" id="L66">        LogstashTcpSocketAppender logstashAppender = new LogstashTcpSocketAppender();</span>
<span class="fc" id="L67">        logstashAppender.setName(LOGSTASH_APPENDER_NAME);</span>
<span class="fc" id="L68">        logstashAppender.setContext(context);</span>
<span class="fc" id="L69">        String customFields = &quot;{\&quot;app_name\&quot;:\&quot;&quot; + appName + &quot;\&quot;,\&quot;app_port\&quot;:\&quot;&quot; + serverPort + &quot;\&quot;}&quot;;</span>

        // More documentation is available at: https://github.com/logstash/logstash-logback-encoder
<span class="fc" id="L72">        LogstashEncoder logstashEncoder = new LogstashEncoder();</span>
        // Set the Logstash appender config from JHipster properties
<span class="fc" id="L74">        logstashAppender.addDestinations(new InetSocketAddress(jHipsterProperties.getLogging().getLogstash().getHost(), jHipsterProperties.getLogging().getLogstash().getPort()));</span>

<span class="fc" id="L76">        ShortenedThrowableConverter throwableConverter = new ShortenedThrowableConverter();</span>
<span class="fc" id="L77">        throwableConverter.setRootCauseFirst(true);</span>
<span class="fc" id="L78">        logstashEncoder.setThrowableConverter(throwableConverter);</span>
<span class="fc" id="L79">        logstashEncoder.setCustomFields(customFields);</span>

<span class="fc" id="L81">        logstashAppender.setEncoder(logstashEncoder);</span>
<span class="fc" id="L82">        logstashAppender.start();</span>

        // Wrap the appender in an Async appender for performance
<span class="fc" id="L85">        AsyncAppender asyncLogstashAppender = new AsyncAppender();</span>
<span class="fc" id="L86">        asyncLogstashAppender.setContext(context);</span>
<span class="fc" id="L87">        asyncLogstashAppender.setName(ASYNC_LOGSTASH_APPENDER_NAME);</span>
<span class="fc" id="L88">        asyncLogstashAppender.setQueueSize(jHipsterProperties.getLogging().getLogstash().getQueueSize());</span>
<span class="fc" id="L89">        asyncLogstashAppender.addAppender(logstashAppender);</span>
<span class="fc" id="L90">        asyncLogstashAppender.start();</span>

<span class="fc" id="L92">        context.getLogger(&quot;ROOT&quot;).addAppender(asyncLogstashAppender);</span>
<span class="fc" id="L93">    }</span>

    // Configure a log filter to remove &quot;metrics&quot; logs from all appenders except the &quot;LOGSTASH&quot; appender
    private void setMetricsMarkerLogbackFilter(LoggerContext context) {
<span class="fc" id="L97">        log.info(&quot;Filtering metrics logs from all appenders except the {} appender&quot;, LOGSTASH_APPENDER_NAME);</span>
<span class="fc" id="L98">        OnMarkerEvaluator onMarkerMetricsEvaluator = new OnMarkerEvaluator();</span>
<span class="fc" id="L99">        onMarkerMetricsEvaluator.setContext(context);</span>
<span class="fc" id="L100">        onMarkerMetricsEvaluator.addMarker(&quot;metrics&quot;);</span>
<span class="fc" id="L101">        onMarkerMetricsEvaluator.start();</span>
<span class="fc" id="L102">        EvaluatorFilter&lt;ILoggingEvent&gt; metricsFilter = new EvaluatorFilter&lt;&gt;();</span>
<span class="fc" id="L103">        metricsFilter.setContext(context);</span>
<span class="fc" id="L104">        metricsFilter.setEvaluator(onMarkerMetricsEvaluator);</span>
<span class="fc" id="L105">        metricsFilter.setOnMatch(FilterReply.DENY);</span>
<span class="fc" id="L106">        metricsFilter.start();</span>

<span class="fc bfc" id="L108" title="All 2 branches covered.">        for (ch.qos.logback.classic.Logger logger : context.getLoggerList()) {</span>
<span class="fc bfc" id="L109" title="All 2 branches covered.">            for (Iterator&lt;Appender&lt;ILoggingEvent&gt;&gt; it = logger.iteratorForAppenders(); it.hasNext();) {</span>
<span class="fc" id="L110">                Appender&lt;ILoggingEvent&gt; appender = it.next();</span>
<span class="fc bfc" id="L111" title="All 2 branches covered.">                if (!appender.getName().equals(ASYNC_LOGSTASH_APPENDER_NAME)) {</span>
<span class="fc" id="L112">                    log.debug(&quot;Filter metrics logs from the {} appender&quot;, appender.getName());</span>
<span class="fc" id="L113">                    appender.setContext(context);</span>
<span class="fc" id="L114">                    appender.addFilter(metricsFilter);</span>
<span class="fc" id="L115">                    appender.start();</span>
                }
<span class="fc" id="L117">            }</span>
<span class="fc" id="L118">        }</span>
<span class="fc" id="L119">    }</span>

    /**
     * Logback configuration is achieved by configuration file and API.
     * When configuration file change is detected, the configuration is reset.
     * This listener ensures that the programmatic configuration is also re-applied after reset.
     */
<span class="fc" id="L126">    class LogbackLoggerContextListener extends ContextAwareBase implements LoggerContextListener {</span>

        @Override
        public boolean isResetResistant() {
<span class="nc" id="L130">            return true;</span>
        }

        @Override
        public void onStart(LoggerContext context) {
<span class="nc" id="L135">            addLogstashAppender(context);</span>
<span class="nc" id="L136">        }</span>

        @Override
        public void onReset(LoggerContext context) {
<span class="nc" id="L140">            addLogstashAppender(context);</span>
<span class="nc" id="L141">        }</span>

        @Override
        public void onStop(LoggerContext context) {
            // Nothing to do.
<span class="nc" id="L146">        }</span>

        @Override
        public void onLevelChange(ch.qos.logback.classic.Logger logger, Level level) {
            // Nothing to do.
<span class="fc" id="L151">        }</span>
    }

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.2.201808211720</span></div></body></html>